function k=compose(i,j,n)
% function k=compose(i,j[,n])
% Renvoie l'indice de la composition des transformations i et j du groupe
% diedral D2n
% Accepte des matrices (de mmes dimensions) pour i et j.
if nargin == 2, n = 4; end % On travaille dans D8 par dfaut
[alphai,betai]=trad_dec_qu(i);
[alphaj,betaj]=trad_dec_qu(j);
alpha = mod(alphai+alphaj,2);
beta = mod(betai.*(-1).^alphaj+betaj,n);
k=trad_qu_dec(alpha,beta);
end