function sg=sous_groupe_engendre_th7(e,n)
% function sg=sous_groupe_engendre_th7(sg[,n])
% Fournit le sous-groupe engendr par les lments passs en argument sous
% forme de matrice ligne.
% e : lment(s)  partir duquel(desquels) engendrer le sous-groupe.
if nargin == 1, n = 4; end % On travaille dans D8 par dfaut
taille = size(e,2);
% Thorme de Lagrange : on a dpass la taille n le sous-groupe est donc
% le groupe complet
if taille > n
    sg = 0:(2*n-1); % Thorme de Lagrange
    return; 
end
sg = e; % Le sous-groupe comprends forcment les lments de dpart
changement = 0;
% Pour chaque lment fourni
for (cpt1=1:taille)
    % On prends le mme, puis les suivants
    for (cpt2=1:taille)
        % Et on effectue une composition
        nouveau = compose(e(1,cpt1),inverse(e(1,cpt2)),n);
        % Si le rsultat n'est pas dj dans le sous-groupe en cours
        % de construction, on l'y ajoute et on note le changement
        if ~any(nouveau == sg)
            % Thorme de Lagrange : on va dpasser la taille n, le sous-
            % groupe est donc le groupe complet
            if size(sg,2) == n
                sg = 0:(2*n-1);
                return; 
            end
            sg = [sg,nouveau];
            changement = 1;
        end
    end
end
% En cas de changement, on reffectue toutes les compositions sur le
% sous-groupe obtenu (lourd, mais efficace)
if (changement)
    sg = sous_groupe_engendre(sg,n);
end
end